package com.ruoyi.bst.snapshot.mapper;

import java.util.List;

import org.apache.ibatis.annotations.Param;

import com.ruoyi.bst.snapshot.domain.Snapshot;
import com.ruoyi.bst.snapshot.domain.SnapshotQuery;
import com.ruoyi.bst.snapshot.domain.SnapshotVO;
import com.ruoyi.bst.snapshot.domain.vo.SnapshotDateVO;

/**
 * 快照Mapper接口
 *
 * @author ruoyi
 * @date 2025-05-08
 */
public interface SnapshotMapper
{
    /**
     * 查询快照
     *
     * @param id 快照主键
     * @return 快照
     */
    SnapshotVO selectSnapshotById(Long id);

    /**
     * 查询快照列表
     *
     * @param query 快照
     * @return 快照集合
     */
    List<SnapshotVO> selectSnapshotList(@Param("query")SnapshotQuery query);

    /**
     * 新增快照
     *
     * @param snapshot 快照
     * @return 结果
     */
    int insertSnapshot(Snapshot snapshot);

    /**
     * 批量新增快照
     */
    int batchInsert(@Param("list") List<? extends Snapshot> list);

    /**
     * 批量修改快照
     */
    int batchUpdate(@Param("list") List<? extends Snapshot> list);

    /**
     * 修改快照
     *
     * @param snapshot 快照
     * @return 结果
     */
    public int updateSnapshot(@Param("data") Snapshot snapshot);

    /**
     * 删除快照
     *
     * @param id 快照主键
     * @return 结果
     */
    int deleteSnapshotById(Long id);

    /**
     * 批量删除快照
     *
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteSnapshotByIds(Long[] ids);

    /**
     * 查询日期快照
     * @param query
     * @return
     */
    List<SnapshotDateVO> selectSimpleForDate(@Param("query") SnapshotQuery query);
}
